//#define DEBUG

#include <vector>
#include <cstdio>
#include <cstdlib>
#include "incursion.h"

using namespace std;

namespace {
    constexpr int VISIT = 473895279, ANSWER = 1979520194;
    constexpr int ALICE = 1337, BOB = 4242;
}

#define write(x) _write_helper(__LINE__, x)
template<typename T> void _write_helper(int line, T t) {
    fwrite(&t, sizeof(t), 1, stdout);
    fflush(stdout);

    #ifdef DEBUG_
        cerr << "[line" << line << "] " << t << flush;
    #endif
}

template<typename T> T read() {
    T x;
    if (fread(&x, sizeof(x), 1, stdin) != 1)
        exit(0);
    return x;
}

int visit(int v) {
    write(VISIT); write(v); fflush(stdout);
    int x = read<int>();
    if(x < 0) exit(0);
    return x;
}

int main() {
    int who = read<int>();
    int N = read<int>();

    vector<pair<int,int>> T(N - 1);
    if(fread(T.data(), sizeof(int), 2 * N - 2, stdin) != 2 * N - 2) exit(0);

    int v = read<int>() + 1;

    if(who == ALICE) {
        vector<int> numbers = mark(T, v);
        int l = (numbers.size() == N ? N : 0);
        write(ANSWER); write(l);
        fwrite(numbers.data(), sizeof(int), l, stdout);
        fflush(stdout);
    }

    if(who == BOB) {
        locate(T, v, read<int>());
        write(ANSWER); fflush(stdout);
    }

    return 0;
}
